This archive contains the replication package of the study on CI landscape in GitHub. 

The file "requirements.txt" contains a list of dependencies needed to execute the scripts, and can be installed using "pip install -r requirements.txt". Before using the Jupyter notebooks, it is strongly recommended to create an isolated environment with Python 3.6. This can be done easily using 'pew' or ''virtualenv'

> pip install pew     
> pew new -p python3.6 -r requirements.txt CIstudy     

or 

> pip install virtualenv     
> virtualenv -p python3.6 CIstudy     

The scripts can be found under the "Notebooks" directory and they must be run with 'Jupyter notebook'. 
Notebook "_A_Data_Cleaning" uses 2 raw datasets of "dataset_raw_700k_allCIs.csv.gz" and "all_activerepos_notfork676K.csv.gz" and generates "NPM_cs_protions_700k_7cis" dataset for "_B_Analysing CI landscape in NPM". All datasets are provided in the data directory.

We used the (https://replicate.npmjs.com/_all_docs) endpoint to be able to get the list of NPM packages and their info. The info we obtained from the API includes:

Name: the package name 
Created: time of the creation 
Updated: last update time recorded for the package
Maintainers_name: name of the maintainer 
Maintainers_email: email address of the maintainer 
Homepage: home page 
Repository: repository address of the package 
Author: author name 
License: license type

Out of the 1,601,989 packages listed in the packages list, we managed to access and clone 676K of them. Using git commands, we extracted files from the entire history of git, then iterated over all commits, and found where CI files were added or deleted.
In order to determine which repositories are forked and which are not, we used the GitHub API.
